import pandas as pd
from datetime import datetime

def drop_columns(df):
  """
  Функционал:
  Удаляет определенные столбцы из датафрейма.

  Параметры:
  - df (pd.DataFrame): Исходный датафрейм, из которого нужно удалить столбцы.

  Возвращает:
  - pd.DataFrame: Датафрейм с удаленными столбцами.
  """
  df = df.drop(['university', 'faculty', 'track_code', 'can_access_closed', 
                'relation_partner.id', 'relation_partner.first_name', 'relation_partner.last_name'], axis = 1)
  return df

def remane_columns(df):
  """
  Функционал:
  Переименовывает и переупорядочивает столбцы в датафрейме с использованием новых имен.

  Параметры:
  - df (pd.DataFrame): Исходный датафрейм, который требуется изменить.
  
  Возвращает:
  - pd.DataFrame: Датафрейм с переименованными и переупорядоченными столбцами.
  """
  df = df.rename(columns={
    'first_name': 'Имя',
    'last_name': 'Фамилия',
    'bdate': 'Дата рождения',
    'followers_count': 'Кол-во подписчиков',
    'university_name': 'Университет',
    'faculty_name': 'Факультет',
    'graduation': 'Год окончания университета',
    'home_town': 'Город рождения',
    'relation': 'Семейное положение',
    'sex': 'Пол',
    'is_closed': 'Скрытый профиль',
    'education_form': 'Тип обучения',
    'education_status': 'Статус обучения'})
  df = df[['id', 
          'Имя', 
          'Фамилия', 
          'Пол', 
          'Дата рождения', 
          'Город рождения', 
          'Семейное положение', 
          'Университет', 
          'Факультет',
          'Тип обучения',
          'Статус обучения',
          'Год окончания университета', 
          'Кол-во подписчиков',
          'Скрытый профиль']]
  return df

def rename_values(df):
  """
  Функционал:
  Заменяет значения в указанных столбцах датафрейма согласно заданным маппингам.

  Параметры:
  - df (pd.DataFrame): Исходный датафрейм, который требуется изменить.
  
  Возвращает:
  - pd.DataFrame: Датафрейм с замененными значениями в указанных столбцах.
  """
  df['Пол'] = df['Пол'].replace({1: 'Женский', 2: 'Мужской'})
  df['Семейное положение'] = df['Семейное положение'].replace({0: 'Не указано', 
                                                               1: 'Не женат / не замужем',
                                                               2: 'Есть друг / есть подруга',
                                                               3: 'Помолвлен / помолвлена',
                                                               4: 'Женат / замужем',
                                                               5: 'Всё сложно',
                                                               6: 'В активном поиске',
                                                               7: 'Влюблён / влюблена',
                                                               8: 'В гражданском браке'})
  df['Скрытый профиль'] = df['Скрытый профиль'].replace({True: 'Скрытый', False: 'Не скрытый'})
  return df

def classify_age(df):
    """
    Функционал:
    - Преобразовывает столбец с датой рождения.
    - Вычисляет возраст.
    - Добавляет новый столбец "Классификация" в датафрейм согласно возрасту.

    Параметры:
    - df (pd.DataFrame): Исходный датафрейм.

    Возвращает:
    - pd.DataFrame: Датафрейм с новыми столбцами "Возраст" и "Классификация".
    """
    df['Дата рождения'] = pd.to_datetime(df['Дата рождения'], errors='coerce')
    df['Возраст'] = (datetime.today() - df['Дата рождения']).astype('<m8[Y]')

    def classify(age):
        if pd.isnull(age):
            return 'Неопределен'
        elif age < 12:
            return 'Ребенок'
        elif 13 <= age <= 17:
            return 'Подросток'
        elif 18 <= age <= 24:
            return 'Юный'
        elif 25 <= age <= 44:
            return 'Молодой'
        elif 45 <= age <= 59:
            return 'Средний'
        elif 60 <= age <= 74:
            return 'Пожилой'
        elif 75 <= age <= 90:
            return 'Старческий'
        else:
            return 'Долгожитель'
        
    df['Классификация возраста'] = df['Возраст'].apply(classify)
    return df
